////////////////////////////////////////////////////
// Programm das die Anwendung eines 1-dim Arrays 
// zeigt. Es wird eine farbige Schlange erzeugt,
// Aufgabe Mengen 2a
////////////////////////////////////////////////////

int laenge = 150; //Länge der Schlange
//xWerte speichert die letzten x-Positionen der Maus
//yWerte entsprechend die y-Positionen
int[] xWerte; 
int[] yWerte;
int dx = 4, dy = 4;

//farben speichert die letzten l Zufallsfarben
color[] farben;
void setup() {
  size(600,600);  
  smooth();
  //Initialisierung
  xWerte = new int[laenge];yWerte = new int[laenge];
  farben = new color[laenge];
  for (int i = 0; i < xWerte.length; i ++ ) {
    xWerte[i] = 300; 
    yWerte[i] =300/2;
    farben[i] = color(255,255,255);
  } 
}

void draw() {
  background(255);
 
  for (int i = 0; i < xWerte.length-1; i ++ ) {
    // xWerte[0] = xWerte[1], xWerte[1] = xWerte = [2], ...
    // xWerte[0] = xWerte[1], xWerte[1] = xWerte = [2], 
    //Die Werte wandern also bei jedem neuen Mauspunkt
    //um eine Stelle nach vorn....
    xWerte[i] = xWerte[i+1];
    yWerte[i] = yWerte[i+1];
    //Auch die Farbwerte wandern bei jedem neuen Mauspunkt
    //um eine Stelle nach vorn
    farben[i] = farben[i+1];
  } 
  
  
  // Neuen Ort und neue Farbe hinten anfügen
  xWerte[xWerte.length-1] = xWerte[xWerte.length-2] + dx; 
  yWerte[yWerte.length-1] = yWerte[yWerte.length-2] + dy; 
  farben[farben.length-1] = color(random(256),random(256),random(256));
  
  dx = dx + int(random(-2, 2));
  dy = dy + int(random(-2, 2));
  if (xWerte[xWerte.length-1]<10) dx = 4;
    else
     if (xWerte[xWerte.length-1]>590) dx = -4;
  if (yWerte[xWerte.length-1]<10) dy = 4;
    else
     if (yWerte[xWerte.length-1]>590) dy = -4;
   
  
  for (int i = 0; i < xWerte.length; i ++ ) {
    noStroke();
    fill(farben[i]);
    //Kreise von klein nach groß
    //Kreise werden proport. zur Wurzel der Position kleiner
    ellipse(xWerte[i],yWerte[i],sqrt(10*i),sqrt(10*i)); 
  }
}